<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<title>Version History PODBot MM</title>
<link rel="stylesheet" type="text/css" href="../index/index.css">
<!-- ###START: MetaData### -->
 <meta http-equiv="Content-Type" content="application/xhtml+xml; charset=ISO-8859-1" />
 <meta name="author" content="SpLoRyGoN & KWo" />
 <meta http-equiv="ImageToolbar" content="no" />
 <meta name="MSSmartTagsPreventParsing" content="true" />
<!-- ###END: MetaData### -->
</head>
<body>
<!-- ###START: Body### -->
<table>
<!-- ###START: Header Table### -->
 <tbody><tr>
  <td id="Banner"><img alt="PODBot MetaMod" src="../index/blank.png"></td>
  <td>
   <ul id="MainNav">
    <li><a href="../index.html">Introduction</a></li>
    <li><a href="./pbmm_install.html">Installation</a></li>
    <li><a href="./pbmm_configuration.html">Settings and commands</a></li>
    <li><a href="./pbmm.html">Usage</a></li>
    <li><a href="./pbmm_wp_basic.html">Waypoints - Basic</a></li>
    <li><a href="./pbmm_wp_commonerrors.html">Waypoints - Common errors</a></li>
    <li><a href="./pbmm_wp_binding.html">Waypoints - Useful keys binding</a></li>
   </ul>
  </td>
  <td>
   <ul id="MainNav">
    <li><a href="./pbmm_credits.html">Credits</a></li>
    <li><a href="./pbmm_versionhistory.html">Version History</a></li>
    <li><a href="./pbmm_linksfiles.html">Links</a></li>
   </ul>
  </td>
 </tr>
<!-- ###END: Header Table### -->
</tbody></table>

<table id="MainContentNavigationTable">
<!-- ###START: MainContent Navigation Table### -->
 <tr>
  <td>
   <table>
    <tr>
     <td>
      <ul>
<!-- ###START: MainContent Navigation### -->
       <li><p class="style_white"><a href="#I">V1.0 (first public release 27/10/2000)</a></p></li>
       <li><p class="style_white"><a href="#II">V1.1</a></p></li>
       <li><p class="style_white"><a href="#III">V1.2</a></p></li>
       <li><p class="style_white"><a href="#IV">V1.4</a></p></li>
       <li><p class="style_white"><a href="#V">V1.4c</a></p></li>
       <li><p class="style_white"><a href="#VI">V1.4x</a></p></li>
       <li><p class="style_white"><a href="#VII">V2.0</a></p></li>
       <li><p class="style_white"><a href="#VIII">V2.5</a></p></li>
       <li><p class="style_white"><a href="#IX">V2.6</a></p></li>
       <li><p class="style_white"><a href="#X">v2.6 metamod Release 1</a></p></li>
       <li><p class="style_white"><a href="#XI">v2.6 metamod Release 2</a></p></li>
       <li><p class="style_white"><a href="#XII">v3.0 metamod Build 15</a></p></li>
       <li><p class="style_white"><a href="#XIII">v3.0 metamod Build 16b</a></p></li>
       <li><p class="style_white"><a href="#XIV">v3.0 metamod Build 16c</a></p></li>
       <li><p class="style_white"><a href="#XV">v3.0 metamod Build 16f</a></p></li>
       <li><p class="style_white"><a href="#XVI">v3.0 metamod Build 17</a></p></li>
       <li><p class="style_white"><a href="#XVII">v3.0 metamod Build 18</a></p></li>
       <li><p class="style_white"><a href="#XVIII">v3.0 metamod Build 18b</a></p></li>
       <li><p class="style_white"><a href="#XIX">v3.0 metamod Build 18c</a></p></li>
       <li><p class="style_white"><a href="#XX">v3.0 metamod Build 19d</a></p></li>
       <li><p class="style_white"><a href="#XXI">v3.0 metamod Build 20a</a></p></li>
       <li><p class="style_white"><a href="#XXII">v3.0 metamod Build 21</a></p></li>	   
<!-- ###END: MainContent Navigation### -->
      </ul>
	  </td>
    </tr>
   </table>
  </td>

  <td>
<!-- ###START: Page Title### -->
   <span>Version History</span>
<!-- ###END: Page Title### -->
  </td>

 </tr>
<!-- ###END: MainContent Navigation Table### -->
</table>

<table id="MainContent">
<!-- ###START: MainContent Table### -->
 <tr>
  <td>
   <table>
    <tr>
     <td>
   <ul>
  <li><a name="I"></a>V1.0 (first public release 27/10/2000)</li>

  <li><a name="II"></a>V1.1</font>
  <span>
	+ FIXED Player Speeds with Weapons<br>
	+ FIXED VIP Speed<br>
	+ Changed Damage Detection Code<br>
	+ FIXED Weapon Kickback<br>
	+ Extended Waypoint Menu System<br>
	+ Implemented hearing Footsteps<br>
	+ Modified Sniper Combat behaviour<br>
	+ More weapon fixes<br>
	+ Bots above skill 70 sneak when Enemy near suspected</span></li>

  <li><a name="III"></a>V1.2
  <span>
	+ Fully compatible to CS 1.0<br>
	+ Recoded all Reaction Routines<br>
	+ Burst Fire implemented<br>
	+ Smarter Grenade Use/Throwing<br>
	+ Bots try to hide</span></li>

  <li><a name="IV"></a>V1.4
  <span>
	+ FIXED: Bunny Hopping of Snipers<br>
	+ FIXED: Crash when adding Bots<br>
	+ FIXED: BotChat Freeze on Win2K (Couldn't test this!)<br>
	+ FIXED: Humanlike Combat Turning Speed<br>
	+ FIXED: Several Bugs in Waypoint Editor<br>
	+ FIXED: Living Bots talking to the Dead<br>
	+ FIXED: Only Host can issue commands<br>
	+ FIXED: Freezetime (first Round) Bug<br>
	+ FIXED: Knife being used when Enemy out of range<br>
	+ FIXED: Bot Chat Spamming<br>
	+ FIXED: Bug in detecting Hostages<br>
	+ Rewrote/optimized the Hearing Code<br>
	+ Bots now hear Shots and Button Usage within their range<br>
	+ Bots randomly use secondary knife mode<br>
	+ Changed Waypoint Movement<br>
	+ Changes in Basic Movement<br>
	+ Changed Waypoint Format<br>
	+ Added some stuff to the waypoint editor<br>
	+ Added Camp Flags to the Editor<br>
	+ Bots above Skill 60 try to stay more covered when moving<br>
	+ Improved Ladder climbing up<br>
	+ Added Bot User Menu<br>
	+ Tweaked Reaction Time again<br>
	+ Improved Enemy Detection Handling<br>
	+ Bots use Zoom Mode when sniping most of the time<br>
	+ Bots Hiding Behaviour improved<br>
	+ Added a bunch of new commands to the Config File<br>
	+ Added Randomness to Reaction Times<br>
	+ Bots are able to swim now<br>
	+ Updated/Replaced all Waypoint Files</span></li>

  <li><a name="V"></a>V1.4c
  <span>
	+ FIXED: Bots don't going mad anymore when flashbanged<br>
	+ FIXED: Hearing Bug when hiding<br>
	+ FIXED: FIXED some Issues with Weapon Kickback<br>
	+ FIXED: Bots keep ducking when seeing an enemy<br>
	+ Added Minimum Turn Amount<br>
	+ Added Noclip Option for Waypoint Editing<br>
	+ Added Terrorist Bots use Hostages under certain conditions<br>
	+ Implemented Proper Sniper Zooming<br>
	+ Increased number of "special" waypoints from 32 to 64<br>
	+ Added some more dedicated Server Commands<br>
	+ Added option to turn on old (1.2) combat behaviour<br>
	+ Added botskill.cfg to tweak all skills to your needs</span></li>

  <li><a name="VI"></a>V1.4x
  <span>
	+ FIXED: Dedicated Server commands not working after "newmap"<br>
	+ FIXED: Bots not shooting when enemy elevation </> than 45 degree<br>
	+ FIXED: Bots responding too fast to Radio Commands<br>
	+ Added fillserver command to DS commands<br>
	+ Recoded the Radio Capturing/Usage (faster & more reliable)<br>
	+ Bots react on many radio commands<br>
	+ Added much better Player Avoidance Code<br>
	+ Bots don't pause until they've seen an enemy<br>
	+ Updated FAQ & Readme (make sure to read them!)<br>
	+ Added the previously missing de_foption wpt file<br>
	+ Added some more localized Botchat translations<br>
	+ New podbot.cfg command "botsfollowuser"</span></li>

  <li><a name="VII"></a>V2.0
  <span>
	+ FIXED: Bots trying to pickup things already picked up before<br>
	+ FIXED: Ignoring of the MAXFOLLOW Variable<br>
	+ FIXED: Radio Commands not working in dedicated Server Mode<br>
	+ FIXED: Crash when deleting Waypoint Nr. 0<br>
	+ FIXED: Waypoints & Path Connections not displayed after
		Map Change<br>
	+ FIXED: Dedicated Server Commands not working after Mapchange<br>
	+ FIXED: Previously broken Covered Movement<br>
	+ FIXED: Previously broken hearing of Shoot & Usage Noises<br>
	+ FIXED: Freezetime 100% working<br>
	+ FIXED: Correct Movement Speeds also in zoomed Mode<br>
	+ FIXED: Weapon Buying in AS Maps<br>
	+ FIXED: Low/High Angles Aiming Bug<br>
	+ FIXED: Included up/down looking at campwaypoints, which was
		present since V1.0 but overseen<br>
	+ FIXED: Better Detection of Killer Entity<br>
	+ FIXED: Diving Problems when swimming<br>
	+ FIXED: Stupid Angle Bug which messed up movement sometimes<br>
	+ FIXED: Bots try to avoid shooting TeamMates (doesn't apply for
		bad Grenading)<br>
	+ FIXED: Bots can't be added if Waypoints not initialised<br>
	+ Redid all the find routines<br>
	+ Better Edge Avoidance<br>
	+ Added Bots picking up weapons on the ground (adjustable
	  through BotWeapons.cfg)<br>
	+ Buying can be customised & personalized in BotWeapons.cfg<br>
	+ Added some Teamchat Messages (Bots using Hostages etc.)<br>
	+ Optimized Waypoint Selection Code (much faster!)<br>
	+ Made Waypoint Selection more Team and Map dependant<br>
	+ Bots use SmokeGrenades and are primitively affected<br>
	+ Redid the whole Movement Code. Bots are now able to move
	  backwards/sidewards while moving to a goal and still check
	  for obstacles in their way<br>
	+ Smarter Combat Strafing/Jumping<br>
	+ Bots now have a small Task-driven Memory<br>
	+ Bots buy all Items (except senseless Nightvision Goggles)<br>
	+ Better enemy detection (more CPU consuming)<br>
	+ Added 3 basic Bot Personalities with adjustable Weapon
	  Preferences<br>
	+ Bots above Skill 80 try to shoot seen/heard Enemies through
	  Obstacles if possible and enabled in Config<br>
	+ Counter Bots share a global memory of visited Bombspots<br>
	+ Bots on same Team share Enemy Knowledge if they see each
	  other<br>
	+ Bots collect Map Experience about Danger Spots (can be
	  turned off)<br>
	+ Bots primitively use Buttons of all types (except cameras)<br>
	+ Changed Inner Workings of Decision Logic<br>
	+ Hearing Sensibility now affected by Movement Speed & own Noises<br>
	+ Bots shoot back (randomly) at teammates who tried shooting them<br>
	+ Added some Performance Settings to podbot.cfg<br>
	+ Added some more useful console commands for configuring
	  and helping when waypointing/debugging<br>
	+ Again better Player Avoidance & Unstuck Code<br>
	+ Using the original HL Engine Speech Synthesis to
	  speak to the Host<br>
	+ Added custom Compress/Decompress Routines for those otherwise
	  much too big Experience Files<br>
	+ Better blinded (Flashbang) Bevahiour<br>
	+ Bots don't loose their leader when seeing Enemies<br>
	+ Improved ladder climbing<br>
	+ Bots shoot at dying enemies (Time based on Agression) if they
	  don't have a new opponent<br>
	+ CT Bots communicate about visited Bombspots. Humans can use<br>
	+ "Sector clear" to tell them about a visited Bombspot too.<br>
	+ Bots pickup things like Bomb or Weapons while following User<br>
	+ Some improvements & fixes to the waypoint editor<br>
	+ Added Bot Model Selection<br>
	+ Added preemptive Firing (based on Agression & skill) to
	  Fleeing/Hunting States<br>
	+ Bots can be allowed to vote against disruptive Players<br>
	+ Bots can be ordered (by the host) to vote for a map<br>
	+ Bots Emotions/Desires are also affected by number
	  of teammates near and current weapon<br>
	+ Some additional Fun-Modes included<br>
	+ Bot Agressions are affected by Roundtime & Team Goals<br>
	+ Waypoint Type Selection now bound to Personality +
	  Agression/Fear + Team<br>
	+ Failed/Succesful Plans are remembered for each Team and<br>
	  stored in the experience files (if not turned off by User)<br>
	+ Bots mostly try to get away from Grenades thrown at them<br>
	+ Bots spray Logos (can be customized & turned off)<br>
	+ Bots now use the correct PVS & PAS</span></li>

  <li><a name="VIII"></a>V2.5
  <span>
	+ FIXED: Ignoring of the BotSpray Variable<br>
	+ FIXED: Wrong Gravity after turning off Fun-Modes<br>
	+ FIXED: Having 2 skills when minbotskill = maxbotskill<br>
	+ FIXED: Getting the Enemy instantly when being shot<br>
	+ FIXED: Nasty Bug in the firing Routine which messed up
    Reaction Times & kept Bots from shooting sometimes<br>
	+ FIXED: Resetting time to reach when being stuck causing Bots
		remaining stuck & doing unnecessary jumps<br>
	+ FIXED: CT Bomb Spot Selection when using Experience Files<br>
	+ FIXED: Bugs & Problems with linked Lists, causing Memory Leaks
	  and random crashes<br>
	+ FIXED: Bots tracking Enemies through Obstacles when camping/hiding<br>
	+ FIXED: All Turns/Movements Frame Independant<br>
	+ FIXED: Bugs in weapon buying on AS Maps<br>
	+ FIXED: First Bot on dedicated Server not moving properly<br>
	+ FIXED: Team mismatch when collecting experience<br>
	+ FIXED: Para/SG550 buying Bug when weapon restriction on<br>
	+ FIXED: Not dropping primary weapon for new one on the ground in
	  extreme situations<br>
	+ Optimized Player Avoidance a bit<br>
	+ Major Rewrite of the debugging core<br>
	+ Complete rewritten Burst Firing, now includes non-automatic weapons
	  and distance to target<br>
	+ Extended Hearing code to include Sounds like Opening Doors, Ladders
	  and a lot more (thanks killaruna!)<br>
	+ Added some more dynamic Symbols to the Chatsystem and a 'Name Humanizer'<br>
	+ Extended Chatsystem to have Bots Reply to user customizeable
	  Keywords + Bots chat with each other when spectating
	  (heavily inspired by ParaBot from killaruna again!)<br>
	+ Smarter Grenade Usage. Bots try to surprise enemies and cancel
	  grenading if they think it won't succeed<br>
	+ Movement now pretty much point precise<br>
	+ Changed Bot DS CVAR and some other stuff to be more compatible to
	  Botmaster5000<br>
	+ Ladder climbing should now handle even difficult stuff<br>
	+ Added Bot Weapon Mode Menu<br>
	+ Removed Bugs in the Aiming Code<br>
	+ Added "waypoint teleport"<br>
	+ Redid Bot Task/Schedule System resulting in more careful Bots etc.<br>
	+ All Radios Commands from 1.4x work again like "GetInPosition..."<br>
	+ Bots defend the planted Bomb and the guy who's defusing<br>
	+ CT Bots "hear" the planted Bomb<br>
	+ Increased Shooting Precision when using zoomed Sniper Weapon<br>
	+ Each Team selects a Leader Bot which issues some basic Radio Orders</span></li>

  <li><a name="IX"></a>V2.6
  <span>
	+ FIXED: DS SERVER CVAR<br>
	+ FIXED: Borg Mode and added extra Borg Cam<br>
	+ FIXED: Misc Bugs when attacking<br>
	+ FIXED: Bots switching to next Weapon when only Ammo in current Clip<br>
	+ FIXED: Duck/Jumping Bug<br>
	+ FIXED: About 3 MB of Memory/Resource Leaks :)<br>
	+ Rewrote func type handling, especially buttons<br>
	+ Aiming now affected by Enemy Velocity & Bot Turns<br>
	+ Bots continue their Tasks if no direct Path to Enemy<br>
	+ CT Bots low on health (or 50% Probability) guard a dropped C4<br>
	+ Rewrote Startup Routines which previously caused the stupid jumping<br>
	+ Smarter Grenade Usage<br>
	+ Correct FOV for each Weapon & Sniping Mode<br>
	+ New Zoom Switching allows better sniping weapon usage<br>
	+ Changes in the Behaviour Code - Bots try to go for Cover faster<br>
	+ Misc changes to the statistics system - depending on Emotions
	  Bots may camp instead of moving to dangerous positions<br>
	+ Bots don't move in Intermission<br>
	+ Bots leave their camping/hiding position if they get hurt by
	  unusual damage like drowning or gas</span></li>

  <li><a name="X"></a>v2.6 metamod Release 1
  <span>
	+ Ported to Metamod by Pierre-Marie Baty<br>
	+ Put all this mess into shape at last (indenting, alignment, comments)<br>
	+ FIXED an impressive number of bugs<br>
	+ Added support for CS 1.6 (shield code thanks to Wei Mingzhi). Be sure to
	  use the new bot_weapons.cfg file else the bot will crash.<br>
	+ FIXED all v2.6 bugs (bomb planting, etc) the way it's meant to be fixed -
	  directly at the spot. No ugly hacks, no "patching".<br>
	+ Before I forget: ported to Linux, too<br>
	+ Forced the bots to always use the A* pathfinder. It should affect greatly
	  the team tactics if used with mature .pxp files.<br>
	+ FIXED waypoint 0 with 65535 danger in default experience table<br>
	+ FIXED waypoint editor not working anymore<br>
	+ Added Austin's super-kickass waypoint editor that he wrote with SoUlFaThEr
	  for the now defunct PoXBot. At least this code won't be lost for everyone.<br>
	+ FIXED new experience database bug related to incorrect memset usage<br>
	+ Got rid of the ugly CVAR parsing for server commands. Using a real dedicated
	  server command handler now. No quotes needed anymore in server commands.<br>
	+ FIXED brainless CT bots taking the hostages through impossible routes<br>
	+ CT bots now pick up abandoned defuse kits (got the idea while reading Wei
	  Mingzhi's YaPB code - worth a look, he ported all the POD-Bot code to C++)<br>
	+ FIXED incorrect danger estimation of waypoint #0 to 65535 the way it's
	  meant to be fixed (diff. between signed int and unsigned short ?? ;-))<br>
	+ FIXED bots not coming back after a map change<br>
	+ FIXED 2 possible crash bugs thanks to Wei Mingzhi again<br>
	+ FIXED incorrect usage of abs() where it should be fabs()<br>
	+ FIXED another weapon selection bug<br>
	+ FIXED imprecise navigation of waypoints on top of certain ladders<br>
	+ I advise you to delete all your previous .pxp files UNLESS they've been
	  used with POD-Bot 2.5 ONLY (and not the buggy 2.6).<br>
	+ The overall performance has been restored to what it used to be with 2.5<br>
	+ Rewrote the messy CS buy routines in a clean way at last<br>
	+ FIXED Count Floyd's experimental A* pathfinder. He was using no heuristic!!!<br>
	+ FIXED bots too shy, was linked to the absence of heuristic function. I wrote
	  a square distance heuristic (no sqrt involved. Fast and efficient)<br>
	+ Because of an important change in the way the pathfinder behaves, you should
	  delete all your .pxp files again, or use untouched .pxp files from PB 2.5<br>
	+ FIXED bots don't buy in CS 1.6 after the first round.<br>
	+ FIXED BotSpawnInit() calls zapping the bot's brains several times in a row<br>
	+ FIXED bots trying to pick up a new weapon without discarding the shield<br>
	+ FIXED VERY COMMON crash bugs in bot chat functions (ThreatTab index > 31)<br>
	+ FIXED yet another whole shitload of crash bugs on bad entities (w/ FNullEnt)<br>
	+ Got rid of the unused MOTD message catching<br>
	+ Bots now know when icons are blinking on their HUD: bomb, defuser, buy zone<br>
	+ Delayed bots buying so that they don't buy all in the same frame (lag issue)<br>
	+ FIXED bots having trouble at doors. Bot navigate doors perfectly now.<br>
	+ Bots pay much more attention to the mission goals now. They don't mess
	  around anymore doing idle stuff, they deploy and go to the goal.<br>
	+ FIXED bots getting stuck on ladders where a func_breakable would block them<br>
	+ Now using ServerActivate() instead of StartFrame() to catch map changes<br>
	+ The A* pathfinder should be faster now<br>
	+ Took the buying code out of the message queue. WTF was it doing there ???<br>
	+ Rewrote team/class selection function: 3 times shorter, twice as efficient.<br>
	+ Now the bot is pretty much more stable.<br>
	+ FIXED metamod not reloading plugin after map change issue<br>
	+ FIXED failing assert() on Linux systems<br>
	+ FIXED a good heap of Linux bugs thanks to the feedback from Bots United<br>
	+ FIXED WPTDEFAULT directory case issue (now the default waypoint folder is
	  "wptdefault" in lowercase)<br>
	+ Added version stamp to the Win32 DLL this way Austin will be happy<br>
	+ Miscellaneous minor fixes<br>
	+ Another pathname fix for linux. All paths and filenames are now in LOWER
	  CASE (that is, no more "BotNames", no more "PODBot", etc.)<br>
	+ FIXED skill not displaying after the bot names when DetailNames is turned on<br>
	+ Took the radio code out of the message queue for simplification<br>
	+ FIXED bots gazing at the sky or the floor (or generally anywhere but where
	  they should have looked at instead) when camping on non-camp waypoints (well,
	  they MIGHT still face walls but then it'll be that they've HEARD something)<br>
	+ FIXED bots moving their gun erratically when camping<br>
	+ Repaired bits of the camping code that was for ages broken in POD-bot (here's
	  another example of confusion between angles and vectors...)<br>
	+ FIXED a stupid bug in my OWN code that was making the bots use the radio less<br>
	+ Removed failing assert() for angle overflow at the end of BotThink(). It was
	  mysteriously failing only on Linux, and the angle was clamped just before.<br>
	+ Now building the Linux binary with the NDEBUG option. It should fix all the
	  assert() issues on Linux but it still won't tell me why these asserts fail!<br>
	+ FIXED usage of a dozen useless variables for showing the waypoint creator at
	  round start where one single variable would have fit for the job<br>
	+ Cleaned up the code again some more<br>
	+ Rewritten the bot chat code in a much cleaner way (bots use the "say" and
	  "say_team" client commands like humans now).<br>
	+ IMPORTANT: added a new knowledge file type for POD-bot: .pvi files. The .pvi
  	files will store the bot's waypoint visibility table on disk instead of
  	recalculating it each time a new map starts. These files will be stored in
  	the waypoints folder along with the .pwf and .pxp files. Like the .pxp files,
  	these .pvi files are deletable (in which case they will be re-created).<br>
	+ FIXED visibility table failing to reload on some level change situations<br>
	+ Moved all the global variables declarations to bot_globals.h and all the
	  definitions to bot_globals.cpp; only header to include now is bot_globals.h<br>
	+ Simplified the waypoint editor code part in waypoint.cpp<br>
	+ Pathwaypoints are not added anymore if they go through func_illusionaries<br>
	+ Simplified some of the utility functions in util.cpp<br>
	+ FIXED quite a few potential crash bugs again. Should be rock stable now.<br>
	+ Changed the waypoint copyright message back to what it used to be in PB 2.5<br>
	+ FIXED bug where bots would clutter together while navigating on ladders<br>
	+ Re-arranged some global variables and rewrote parts of bot.cpp for better
	  ANSI C compatibility<br>
	+ FIXED very nasty crash bug in IsGroupOfEnemies function<br>
	+ FIXED EXTREMELY NASTY crash bug in BotFindItem(), here's what happens when a
	  coder declares variables everywhere but on top of the functions !!!<br>
	+ FIXED shitloads of crash causes in the waypoint editor. Now when you edit
	  waypoints, all the bots are frozen. And once you save and exit editing mode,
	  the map restarts in order to recalculate the visibility table.<br>
	+ Made the spawn points display a translucent player model in WP editing mode.
	  May help waypointers when they want to put one waypoint at each spawn point.<br>
	+ FIXED buying code that was stuffed up in CS 1.5 because of the bots not being
  	able to use the same buy shortcuts as real clients.<br>
	+ Miscellaneous (very) little fixes in Austin's waypoint editor.<br>
	+ Waypoint editor: now displaying INCOMING path connections in brown (according
	  to an idea from SoUlFaThEr)<br>
	+ FIXED bots taking the hostages only to the last rescue waypoint placed (first
	  waypoint in the linked list). Now the bots take them to the closest one.<br>
	+ Added "autopath on/off" command to toggle automatic pathwaypoint creation.<br>
	+ Added "autopath setradius N" command to enlarge/shrink the automatic
	  pathwaypoint placement radius.<br>
	+ Tweaked the A* pathfinder so that the bots pay more attention to dangerous
	  routes and choose different paths as often as they can<br>
	+ Added a console command/podbot.ini file option to tweak the bot's pathfinder:
	  "danger_factor" (an explanation is provided in the podbot.cfg file)<br>
	+ Removed obsolete "newmap" command.<br>
	+ Denied creation of pathwaypoints from any waypoint to itself.<br>
	+ VIP bot will now have a "coward" personality by default (no more VIP rushing
	  with that ridiculous pistol straight in front of hordes of AK47-armed Ts).<br>
	+ FIXED a bug where checking for waypoints validity after modifying them would
	  unfreeze the bots while still in waypoint editing mode.<br>
	+ CT bots now react immediately when they receive the "bomb planted" message<br>
	+ CT bots don't decide to camp anymore once the bomb has been planted<br>
	+ FIXED bug where bots would not pick up the C4 anymore when they see it<br>
	+ Terrorist bots now go and pick up a dropped bomb as soon as they receive the
	  dropped bomb message and they see the blinking point on their radar (unless
	  they've been scared off, or another good reason though).<br>
	+ Terrorist bots now reevaluate their goal immediately as soon as they receive
	  the message "someone picked up the bomb".<br>
	+ Rewritten player collision code, bots should avoid each other a little better
	+ Tweaked some timers so that bots should camp a bit less now.<br>
	+ FIXED bug where bots would not alternate their camp directions.<br>
	+ FIXED a bug where CT bots could not be added (choosing auto team instead).<br>
	+ Waypointers can now type "ap" instead of "autopath".<br>
	+ FIXED strafe key bug (thanks Whistler)<br>
	+ FIXED potential crash bug by ThreatTab array overflow (thanks Whistler)<br>
	+ Bots should not be trying to toss grenades over the walls in de_dust or
	  through the ceilings like in de_nuke anymore.<br>
	+ Finally FI-XED wicked bug of bots not able to see through certain types of
	  glass !!! <img src="../smileys/bu_w00t.gif"><br>
	+ Bots should approach crouched waypoints correctly now (ducking)<br>
	+ Bots now estimate crouched waypoints using a slower travel speed while
	  pathfinding (should help them not believe crouched routes are the fastest)<br>
	+ FIXED bug where bots would spin around with the head upside down (!!!)<br>
	+ Made the waypoint index display cleaner in waypoint editing mode. It doesn't
	  flood the console anymore and it's visible in CS 1.5 and 1.6 identically.<br>
	+ FIXED "wp teleport" function in the waypoint editor so that players can't be
	  stuck into the ground anymore when teleporting from one waypoint to another.<br>
	+ FIXED incorrect recording of "campstart" and "campangle" angles when adding
	  a waypoint. These values are meant to be ANGLES, NOT vector locations.<br>
	+ Added SoUlFaThEr's waypoints for all the default CS maps.<br>
	+ FIXED thoroughly all the camping direction code to use ANGLES instead of
	  vectors (campStart and campEnd). ***OLDER WAYPOINTS NEED TO BE RE-CHECKED***<br>
	+ Merged Austin's new menu in the WP editor to set the autopath max distance.<br>
	+ FIXED crouching wpt getting taller when getting close (to please sPlOrYgOn)<br>
	+ Rewrote FL_NOHOSTAGE waypoint handling in a clean way.<br>
	+ Merged ThreatTab and Clients array together (they describe the same thing)<br>
	+ Cleaned the message queue stuff and insertion/retrieval code<br>
	+ IMPORTANT: moved the root directory from "podbot" to "addons/podbot"<br>
	+ FIXED another crash bug in StartFrame()<br>
	+ Rewritten parts of the ladder handling code in a more efficient way<br>
	+ FIXED bug where bots would always hold the "strafe left" key pressed<br>
	+ FIXED bug where deleting the last waypoint would crash the waypoint editor<br>
	+ Waypoints with the FL_NOHOSTAGE flag show up graphically in the editor
	  when you issue the "waypoint nohostage" or "wp nohostage" command.<br>
	+ Displayed all waypoint flags graphically live in the waypoint editor<br>
	+ Removed obsolete "waypoint showflags" command.<br>
	+ FIXED bots getting stuck trying to look into external camera screens<br>
	+ Tweaked some graphics in the waypoint editor<br>
	+ Bots now draw the knife to reach high places at jump wpts when necessary<br>
	+ Bot's aim don't wiggle anymore now when looking at waypoints with a radius<br>
	+ Added recognition of armoury_entities for maps like fy_iceworld<br>
	+ Added ability to create/remove multiple pathwaypoints simultaneously<br>
	+ Enforced checking for unique bot names during bot creation to avoid doubles<br>
	+ FIXED YET ANOTHER crash bug in StartFrame() in the config file parsing code<br>
	+ Rewritten completely the config file parsing code: was too messy<br>
	+ Rewritten completely the bot spawning code into something readable<br>
	+ Rewritten the usage of min_bot and max_bot so that these variables work<br>
	+ All the bugfixes submitted by the people on the Bots United forum have been
	  incorporated/committed into the bot code.<br>
	+ Completely rewritten the menu display code to make it readable and easily
	  understandable by any third-party source code hackers.<br>
	+ Added the ability to point the gun at a waypoint and create/delete incoming
	  and outcoming paths to this waypoint by a single keypress in editing mode<br>
	+ FIXED creation of pathwaypoints to the same waypoint bug when jumping<br>
	+ Added yes/no confirmation questions to important editing events in the
	  waypoint editor such as save nocheck, or waypoint/pathwaypoint deletion<br>
	+ Teleporting player automatically to the faulty waypoint when doing a check
	  on the waypoints and the check fails<br>
	+ Rewritten the editor's waypoint beam display code to be more reactive to
	  player movement (now updates every 1/10th second)<br>
	+ Added the ability to remember a waypoint and use it later for pathwaypoint
	  creation/deletion. Helps a lot for lifts.<br>
	+ Added basic code for elevator/lift usage (see demos on the BU filebase)<br>
	+ Added the ability to toggle on/off individually each single waypoint flag<br>
	+ Bots don't press buttons randomly now but only where a button flag is set<br>
	+ Bots navigate button-controlled doors perfectly, even in groups.<br>
	+ Rewritten waypoint stats command to make it display much more information
	  about the waypoints, now displaying each waypoint flag.<br>
	+ Rewritten large parts of the memory allocation code. Static memory is used
	  more often and the slow-motion bug has vanished in the process (the problem
	  was that all the bot memory was not correctly freed/was freed twice).<br>
	+ FIXED bug where bots would reload way too often, such as after 2 shots.<br>
	+ All of the bot config files are now re-read at each start of a new map, so
	  you don't need to restart your server if you make changes in the bot config.<br>
	+ The danger directions that the bots learn for each waypoint are now shown
	  using a large red line when waypoints are on (but not when editing them)<br>
	+ Bots climbing ladders aim correctly at the top or the bottom of the ladder<br>
	+ Bots can now shoot at enemies while navigating ladders. Watch out.<br>
	+ Bots navigate elevators quite well, but not easily in groups. The code is
	  here just to show that lifts can work. Feel free to make it work better :)<br>
	+ Rewritten parts of the BotDoWaypointNav() and BotHeadTowardWaypoint() funcs
	  so as to integrate the new door code, the button code, ladder and lift code.<br>
	+ Bots now draw out the knife when necessary when they do a long jump<br>
	+ Simplified a lot of things in the config file parsing code and the chat code
	  to use static arrays instead of dynamically-allocated linked lists whose main
	  purpose seemed to be only to clutter up the code. It's just readable now.<br>
	+ Added a "peace mode" feature where bots ignore their enemies. Useful when
	  testing paths with debuggoal in waypoint editing mode.<br>
	+ You'll simply love that waypoint editor, lads.<br>
	+ ...</span></li>

  <li><a name="XI"></a>v2.6 metamod Release 2
  <span>
	+ Changed the way all the addbot commands work. Instead of actually 
	  adding a bot it'll add it to a bot creation queue.<br>
	+ Made APMD apply to adding pathes<br>
	+ maxbot/minbot now "works"<br>
	+ Made the AIM_OFFSET_X/Y/Z actually do something..<br>
	+ Made them reaim at enemy every 0.05 second (at least I think its in seconds)<br>
	+ FIXED timer_pickup to recieve the correct value<br>
	+ Menu to choose which team to kick a bot from<br>
	+ FIXED "Unnamed" bots.<br>
	+ Changed them from making their enemy's position their destination.. (Stopped
     them from idioticly running up to an enemy.. No one actually wants to reach
     the enemy's location while they're shooting at them...) (commented out in
     the first few lines of BotDoAttackMovement)<br>
	+ Initialize msec values in ServerActivate (Supposed to fix slow-mo)<br>
	+ Added ability to choose which team to kick a bot from<br>
	+ FIXED them from having an extra new line at end of their chatting.<br>
	+ FIXED their weapons menu and hopefully all that was messed up with the
	  weapons due to the port to 1.6 (they were buying "restricted" weapons
	  because the configurations and everything was wrong)<br>
	+ FIXED NUM_FOR_EDICT error (hopefully... made it check if edict is null
     before running ENTINDEX)<br>
	+ Botskill.cfg is now fully interpreted and I've tweaked all the
	  settings in it.<br>
	+ Changed Their turn speeds to be more realistic...<br>
	+ Made Zooming affect their Turn Speeds<br>
	+ Put most of the ClientCommands into Podbot_ServerCommands<br>
	+ Added Personality argument for addbot.
     ("pb addbot [skill [personality [team [model [name]]]]]")<br>
	+ Added Skill, Personality, and Model for fill server
     ("pb fillserver [skill [personality [team [model]]]]")<br>
	+ Added Menus to include the 2 above changes and also added a random
     for skill level.</span></li>

  <li><a name="XII"></a>v3.0 metamod Build 15
  <span>
	+ Changed: all settings in podbot.cfg are cvars since now.<br>
	+ Changed: addbot is replace by add command (the syntax is the same)
	+ Added: access to podbot menu when the game is created on dedicated server.<br>
	+ Changed: Bots detect friend/enemy according to the TeamInfo messages instead checking the model 
	  (it should work correctly with such mods as SuperHero, ChickenMod etc). Thanks to T(+)rget (AMX), 
	  Bailopan (AMX MOD X) and THE_STORM.<br>
	+ Added: support for compatibility with weapon restriction management done by fan mods (as AMX, AMX X, 
	  AdminMod, ClanMod) - if weapon is restricted for human-players - bots will not buy that item , too :)<br>
	+ FIXED: bug in auto add / kick bot function (when there were some players on the server before adding bots 
     - first bot got kicked instantly after adding it).<br>
	+ FIXED: Bots are spawned with cleared correctly every data (before they were cleared only at round start, 
	  but to support CSDM they have to be cleared at every respawn).<br>
	+ FIXED: Now bots don't throw nades in jason mode. <br>
	+ Changed: the task system - the tasks aren't still placed on the task's stack over and over again - instead this only
     one task of each kind may be placed on the tasks' stack (and prorities are tested by a separate function).<br>
	+ FIXED: Bots don't look at the wall all the time (if last enemy is far away - they forget it much more now 
	  - so they don't look at the wall in the last enemy direction.<br>
	+ Changed: Bots look around more often now.<br>
	+ FIXED: Bots don't spray anymore since spraying is disabled.<br>
	+ FIXED: Bots unzoom (while using weapon with zoom) if they don't look far away or they look at the wall 
	  near of them.<br>
	+ Changed: Bots should jump a bit less if they "think" they stuck.<br>
	+ FIXED: Bots should hear everything around good again.<br>
	+ FIXED: Crash with server commands (thanks to KRoT@L - AMX). <br>
	+ Changed: the work of add bot and kick bot menu (after adding one or kicking one You can still continue 
	  adding / kicking bots without necessity to re-open the main podbot menu).<br>
	+ Changed: After blinding bots don't shoot everytime at last enemy position (it's randomized now).<br>
	+ Changed: the usage of nades by bots - bots are trying to throw flashbangs into corridors; whole nades 
	  should be thrown more precise now.<br>
	+ Changed: Better team playing (they use "follow me" function and they follow all condition included in path 
	  they walk (according to flags in waypoints they pass - for example jumps).<br>
	+ Changed: Bots don't buy primary weapons on aim_xxx, awp_xxx maps.<br>
	+ Changed: the skills of bots are now much different - there is realy apparent difference between bot 
	  with skill (100) and bot (80).<br>
	+ Changed a bit the usage of statistic/experience (to better usage by A* function).<br>
	+ FIXED: bots don't reply on chats.<br>
	+ FIXED: Bot stayed as spectators instead joining the team after 08.2005 Steam update.<br>
	+ FIXED crash on de_chateau (related to breakables)<br>
	+ FIXED: Bots not switching to pistols when enemy is close and they use a sniper rifle<br>
	+ FIXED: Bots not buying ammo if they have a gun already<br>
	+ Bots now pick up pistols!<br>
	+ Bots will now stop before shooting (makes them easy targets but at least they can hit their target now)<br>
	+ NEW pb command "pb_version" will return the current version - can be used on servers with HTML - to see how 
	  many servers is playing podbot mm.<br>
	+ Bots are a bit harder..<br>
	+ Bots can now shoot HUGE HUGE HUGE breakables... (a bit overexaggerated)<br>
	+ Changed "remove" syntax... (pb remove [#PLAYERID || "BOTNAME"])<br>
	+ Changed KickBot Menu<br>
	+ Bots can climb ladders a bit better..<br>
	+ FIXED jason mode<br>
	+ Added variable to delay bots' re-join on the new map start (mapstartbotdelay)<br>
	+ Lift code rewritten - watch 2 new demos in filebase.<br>
	+ Added autokill function (cvars pb_autokill 1|0 and pb_autokilldelay time_sec) - it will kill bots (if pb_autokill 
	  is set to 1) automatically if there are some human players on the server, but all of them got already killed.
     But if the bomb is planted and there is no more alive human-players - the auto kill doesn't kill bots in this situation.<br>
	+ Optimized code to have lower CPU usage.<br>
	+ FIXED - bots shouldn't steal anymore Your hostages You are trying to rescue (after pressing "use" button).<br>
	+ Bots don't try to go to the rescue point if they don't have already a hostage (hostage got killed or some human-player stoled it).<br>
	+ Added - bots wait until the hostages they follow it are rescued (they reach the rescue point) - it means if You place 
	  in a wrong place a WP with Rescue flag (not in the Rescue Zone) - the bot will wait there forever - because 
	  they will be never rescued (thanks to Ancient showing the bug).<br>
	+ FIXED burst mode in low distances to enemies.<br>
	+ FIXED the problem with weapon_strip (thanks to strelomet).<br>
	+ Changed and improved nades throwing - bots should aim better the position they want to throw the nade (the old calculation 
	  of the place the bot should look at during nade throwing was a bit strange).<br>
	+ Added - to unstuck code "go back" function has been added (to existing jump, strafe, duck).<br>
	+ Changed unstuck behavior - improved strafe and go back method in unstuck code. They should try to omit/obey the obstacle 
	  (or a bit go back and try again) instead jumping only.<br>
	+ Changed the code for players colision detection (they should less jump now and more often use strafe and go back).<br>
	+ FIXED - bots don't throw nades now in "ignore enemies" mode.<br>
	+ Added 2 new commands (exactly old command with new arguments) for waypointers:<br>
	  pb wp teleport use - teleports the waypointer to the next waypoint with the flag USE_BUTTON<br>
	  pb wp teleport camp - teleports the waypointer to the next waypoint with the flag CAMP<br>
	  These commands are usefull if You are trying to fix old PB2.5 waypoint with old method of camp usage (with pb mm the old 
	  camp waypoint is causing to look the bot in some strange direction) and also with USE_BUTTON (old PB2.5 was placing that 
	  flag on every WP existing near some func_button - it may cause sometimes stupid behavior of pb mm bots if they have nothing 
	  to "use", but there is placed that flag).<br>
     The old "pb wp teleport wp_nr" is still working like before.<br>
	+ FIXED pb_debuggoal - it should work now everytime (before I noticed few situations they didn't want to go the WP I was 
	  requesting them to go).<br>
	+ Changed the execution of the task FOLLOW_USER - bots should follow the user this way - they should take some random WP near 
	  their user (but connected to the closest one to the user). If they are somewhere near their user, they should look at him 
	  (except if there is some enemy near by) and they should better unstuck if they are close to them-selves (to make a room to go).<br>
	+ Changed - if the bot cannot reach its waypoint in some certain time it should reach it (or bot was doing some 
	  unwaypointed movement), during finding the WP near by it checks also the previous WPs and the current WP (for some reason before 
	  it wasn't so) and it checks if the new WP isn't in some danger (to fall down) area.<br>
	+ Smarter Button flag/Door Button code.<br>
	+ Changed Button code - if there is a USE_BUTTON flag - they randomly decide to push or not the button (after first time 
	  noticing the WP with that flag; next vistit this WP -> new decision about pushing).<br>
	+ FIXED button code - bots shouldn't stay anymore near some button and look infinitely at it.<br>
	+ Changed - bots will hunt enemies more often now - normal and agressive ones - if there is the number of alive players in 
	  one team more or equal than (2 * alive players) of the other team - they will try to hunt them (for example 2CTs alive and 4Ts 
	  alive (or more) - these normal and agressive T bots will start to hunt CTs :) ) - of course it depands of the current level of bots
	  fear/agression.<br>
	+ Config file podbot.cfg is no longer reloaded on the new map start<br>
	+ All config commands are possible to change during the game from console
	  by typing "pb command_name [arguments]"<br>
	+ All config commands need everywhere the prefix "pb" (on listenserver, on DS and in podbot cfg).<br>
	+ FIXED bug apearing on linux servers (auto teleporting bots to (0,0,0) ).<br>
	+ FIXED bots changing personality to normal after a change of map.<br>
	+ FIXED min_bots and max_bots not working correctly.<br>
	+ FIXED TKing bots due to new player models in CZERO.<br>
	+ Made the bot's turning more realistic (thanks to Pierre-Marie Baty and Aspirin for botaim and botaim2 plugins).<br>
	+ Made them buy grenades more (thanks to bluebyte)<br>
	+ FIXED NUM_FOR_EDICT error.<br>
	+ FIXED crash on cs_bigbrother_beta1 (related to grenade throwing).<br>
	+ FIXED typo in botweapons.cfg<br>
	+ FIXED Waypoint Cache not showing right number.<br>
	+ FIXED weapon buying screw up when changing weapon modes on a assasination map.<br>
	+ Bots will now shoot through teammates if mp_friendlyfire is off.<br>
	+ Bots reload more now thanks again to bluebyte :)<br>
	+ Bots can now spray logos again.. thanks to g4s for pointing this out.<br>
	+ Bots switch to pistols when primary is a sniper rifle.<br>
	+ FIXED a crash that would occur when there were experience files for the map and you happen to have waypoints on and 
	  you walked to waypoint #0 without changing any waypoint data.<br>
	+ Automatic Ladder connections now made within Auto-Path Max Distance.<br>
	+ New Waypoint Colors..<br>
	+ Waypoint that is being pointed at is now ENLARGED and has a little blue thing on top of it.<br>
	+ Play in cs:cz without the need to modify the source!<br>
	+ Improved bots shooting breakables.<br>
	+ FIXED bots not taking out the bomb and trying to plant.</span></li>

  <li><a name="XIII"></a>v3.0 metamod Build 16b
  <span>
	+ Changed - Bots shouldn't make bots-towers on ladders anymore (they test all the ladder right now - 
	  not only if the current WP is used by another bot - like it was before).<br>
	+ Changed - the creation of the visibility table doesn't lag the server anymore.<br>
	+ FIXED - the WP editor - now You should more easy and more precisly point the WP You want 
	  to manually make the path connection.<br>
	+ Fixed problem with hostages (bots ignored them a lot instead pickuping them).<br>
	+ Changed the behavior of finding goals (it was too much randomized - almost not related
	  to the current bot "feeling" - now the weight between random and "feel" choice of the goal is changed more 
	  to the "feel" - twice more than random). So now they should focus more on the "mission".<br>
	+ FIXED another problem with hostages (few times pickuped by a bot the same hostage).<br>
	+ FIXED (my) mistake in the waypoint editor - now when You point some waypoint - the manual path 
	  connection will be done with that pointing WP. If You have sme trouble with pointing a WP - 
	  just try to point the middle of its height.<br>
	+ Added 2 new cvars requested by Austin: pb_bot_quota_match and pb_bot_join_team.<br>
	+ Added - You can set the debuggoal index from the WP menu from "Options". On the same page You can switch it off.<br>
	+ Added - FFA (free for all) mode - to switch it on/off for bots You need to use the new cvar - pb_ffa.<br>
	+ Fixed problem with throw flashbang at round start at cs_militia.<br>
	+ Approved a bit unstuck code at round start (still not perfect yet).<br>
	+ Bots should be harder now (requested by a lot of people).<br>
	+ FIXED usage of time frame interval value in the code (to predict the position of the enemy in the next frame or so).<br>
	+ FIXED and re-written bots hearing stuff (bot are affected by their own-sounds, are affected also by sound 
	  of teamnates and also the distance froom the source of issued sound to the bot has the influence for this what 
	  the bot can hear.<br>
	+ Bots will shoot more often through the wall (because of the fix above).<br>
	+ For pb_bot_quota_match parameter the spectators or team unnasigned human-players aren't counted.<br>
	+ FIXED problem with breakables the bot is trying to pass because the waypointer made the connection through it.<br>
	+ The values of cvars are taken as pointer members now (the addresses-pointers are cached at the initialisation 
	  of the vars, then - instead using CVAR_GET_FLOAT (which is taking too much time) I just use the values addressed 
	  by these pointers to the cvars (main idea taken from AMX MOD X - thanks BAILOPAN)<br>
	+ Bot should look at the head of the pickuping hostage instead of his stomach...<br>
	+ FIXED bug with shoving/pushing hostages intead pickup/use them by bots.<br>
	+ Changed the system of finding bombs by CTs (before they were trying to go the closests goal WP, then they were 
	  randomly choosing another one; currently if they choose some goal WP and they are near it and they cannot hear the bomb, 
	  they check some farer away goal WPs - to prevent visit for example 5 goal WPs at the same bomb site if they cannot hear 
	  the bomb at that bomb site).<br>
	+ Bots should camp a bit more often instead rush all the time.</span></li>

  <li><a name="XIV"></a>v3.0 metamod Build 16c
  <span>
	+ Bots should aim better farer away targets.<br>
	+ Bots should better recognize if they can or they cannot hurt their friends while shooting.<br>
	+ Bots should use the knife more often in shorter distances.<br>
	+ Bots should better try to find the bomb to defuse it (CTs).<br>
	+ FIXED problem with the lift on as_highrise (the lift with the door) - such lift needs also the special 
	  waypointing - example in BU filebase.<br>
	+ Added the new cvar pb_skin which forces the usage by bots the specyfied skin 
     (1..4 - forced skin; 0,5 - no forcing) regardless of "pbb add" or "pb fillserver" parameters.<br>
	+ Added support for pickuping weapons created by CSDM 2.x (by BAILOPAN) in item mode.</span></li>

  <li><a name="XV"></a>V 3.0 metamod Build 16f
  <span>
	+ Bots should pickup also "worse" weapons (better/worse - according to the weapon's priorities in botweapons.cfg) 
	  if the current "better" weapon is out of bullets.<br>
	+ Added support for pickuping ammo, nades, armor, medkit in item mode of CSDM (or on maps fy_xxx).<br>
	+ FIXED bug with bots not being able to pickup even "better" secondary weapon.<br>
	+ Changed - the entity player_weaponstrip will get as v.target and as v.targetname the value "fake" only if v.target 
     is empty string.<br>
	+ Bots should think a bit less before shooting (which should make them a bit harder again, I hope).<br>
	+ Added the possibility to unlimit pickuping weapons by bots (pb_maxweaponpickup = -1).<br>
	+ Added the code if the bot cannot pickup something (for some reason) during 4 seconds - he will mark that entity as ignored 
	  (to stop task pickup item).</span></li>

  <li><a name="XVI"></a>V 3.0 metamod Build 17
  <span>
	+ FIXED - The bots shouldn't think now too much before shooting.<br>
	+ Changed - The algorithm to check if the bot can hurt a friend while shooting should work a bit better.</span></li>

  <li><a name="XVII"></a>V 3.0 metamod Build 18
  <span>
	+ Changed - in fireing weapons - they should have really little pauses between shooting. It makes them harder again.<br>
	+ Added the possibility to switch on/off radio command usage and reaction on them (as a side-effect).
	  You can change this setting by pb_radio 0/1.<br>
	+ Changed - bots should camp more often if they have some sniper weapon, they shouldn't if they don't have any rifle 
	  or any sniper weapon (except they defend for example the planted or dropped bomb or so).<br>
	+ FIXED bug with bots not changing the camping direction every few seconds.<br>
	+ FIXED bug with bots unable to unstuck for long period time (unstuck code works much better again).<br>
	+ Changed - bots should find better the planted bomb according to this what they actually can hear (if in some area 
	  the bot cannot hear the bomb - he marks all goal waypoints in that area as "visited" without necessity checking 
	  them separately).<br>
	+ Changed - the bots are more forced to rescue hostages after pickuping them (it happened a lot of times the bot 
	  got a hostages, then he was walking around the map instead to go to the rescue point).</span></li>

  <li><a name="XVIII"></a>V 3.0 metamod Build 18b
  <span>
	+ FIXED bug with bots not planting the bomb (while debugging I saw the bot "thinks" it has mp5navy instead C4 instead 
		in its hands, but it even haven't had mp5navy at all).<br>
	+ FIXED bug with pb_minbots not working correctly since pb_botquotamatch has been implemented.<br>
	+ Added - the bots should run better on higher fps PC (some addition to msec code calculation).<br>
	+ FIXED - the bots should react on a sound better again (I've noticed a lot of times I was fireing at them 
		and they weren't reacting at all like without hearing me).<br>
	+ Added/fixed - the bots should switch to better weapon after hearing the enemy nearby (except they are 
		planting/defusing the bomb). Because of that they may use nades less often.<br>
	+ FIXED - when the bot is shooting at the enemy behind the wall, he shouldn't hit him the same way as he could hit him 
		while seeing him (for example by one shot into the head). It should be more randomly now.
	</span></li>

  <li><a name="XIX"></a>V 3.0 metamod Build 18c
  <span>
	+ Optimized a bit the code to reduce CPU usage.<br>
	+ Changed - visibility table is now saved at round end (the first round end after is calculated - instead at map change).
	</span></li>

  <li><a name="XX"></a>V 3.0 metamod Build 19d
  <span>
	+ FIXED - the bots shouldn't shoot at the exact position of the enemy behind the wall anymore.<br>
	+ Changed minimum delays of some weapons (to get them more accurate for longer distances).<br>
	+ Changed - blinding bots by AMX/AMX X ATAC plugins should affect them better.<br>
	+ Changed - the bots should better escape from bombzone (CTs - if they don't have any chance to defuse - too small amount of time; 
  	T - about 20sec to explosion; psycho T's don't care).<br>
	+ Added - the bots should use the shield much better than before (attackers don't try to loose the whole ammo, defenders - they are 
  	trying to cover by it better and shoot with a pistol so often as possible).<br>
	+ Optimized the usage of CS messages by using static instead dynamic variables (should reduce again the CPU usage).<br>
	+ Changed - the bots should use the shield much better than before.<br>
	+ FIXED targeting VIP's first by Ts on as_xx maps.<br>
	+ Changed - for linux i386 (32 bit) compiled with gcc4.1 (the new crosstool - big thanks to ghost_of_evilspy) - the old library 
  	libstdc++5 will not be necessary anymore to load the binary file (podbot_mm_i386.so).<br>
	+ Changed - if bots get stuck on ladders with teamnates they should try to go to some previous waypoint (near the ladder).<br>
	+ FIXED some litte problem with breakables (the bots failed to break a breakable if the path between 2 waypoint across a breakable 
  	was longer than 128 units - very rearely bug).<br>
	+ Added the new function to the Waypoint Editor - pb wp clean (as the console command only).<br>
  	This function cleans up some stupid and unnecessary connections. If there is no argument, it takes as the argument the nearest 
  	waypoint and it checks its paths (for example if there are 3 connections - 1 to a farer away WP between 2 placed nearby or so). 
  	You can also put as an argument the WP index number You want to clean. You can also put the string "all" (without qutes as 
  	an argument - pb wp clean all) - it will cleanup all unnecessary connections from the map. I'm using this function to remove bad 
  	connections created by some beginner Waypointers (also created by me few years ago).<br>
  	Note - sometimes after using this function with argument "all" You can also loose about 1-2% of the connections they were expected 
  	(as done correctly), but because of the big advantage in cleaning up the map from bad connections it's really recomended if You want 
  	to re-waypoint some map waypointed some time ago by some poor waypointer. It reduces the time to make waypoints from scratch. 
  	If You have the map covered correctly by waypoints You need only add few waypoints like jumps, camps, Team specific, goals, rescue 
  	etc and more than likely You can finish waypointing the map in an hour. If this function will delete some paths they were expected 
  	- the WP editor will tell You if there is any broken connection while saving pwf - so You don't need to be afraid of using this 
  	new function.<br>
	+ Added facing filtering and fixing shaking the bot all the time.<br>
	+ FIXED problem with bot towers on ladders (the bot goes away from the ladder and it waits 
  	a bit if a teamnate is already using the ladder).<br>
	+ Changed WaypointNodeReachable function for adding waypoints and selecting a better alternatives if the waypoint is in use by someone else.<br>
	+ Improved omitting the obstacles with strafing (unstuck code).<br>
	+ Improved detection if the bot can move forward/back (unstuck).<br>
	+ FIXED small problems with collecting experience data.<br>
	+ FIXED problem with looking at the strange direction while camping.<br>
	+ FIXED small problem with reloading the weapon.<br>
	+ Changed - the function WaypointAdd is rewritten a bit to prevent making stupid connections, too, so You can now use more effectively 
  	the function AutoWaypointing. All advanced waypointers normally haven't been using it - because of a lot of stupid connection the 
  	function WaypointAdd was creating (it needed manually clean up all those stupid connections - it was taking too much time), but since 
		now You can use it (AutoWaypointing) much frequently to make waypoints for Your favourite maps more effectivelly.<br>
	+ Improved aiming at waypoints more accurate now (Waypoint Editor).<br>
	+ Changed the info shown for waypoint editor (it shows more info now).<br>
	+ Changed the refresh of drawing waypoints (every 0.1 sec separatelly for each waypoint).<br>
	+ Changed a bit aiming the target by bots (taken some idea from YapB).<br>
	+ Added some commands concerning to experience data:<br>
  	pb experience show - shows the data stored in the pxp file<br>
  	pb experience test_a_T ind1 ind2 byPathType - shows the path the Terrorist bot would like to choose from WP ind1 to WP ind2 according 
  	to kind of algorithm :<br>
	  	byPathType = 0 - the shortest way according to distances between waypoints (used by aggressive bots),<br>
	  	byPathType = 1 - the shortest way according to distances between waypoints and to the collected experience (damages collected - 
    	used by normal bots),<br>
	  	byPathType = 2 - the shortest way according to collected experience (no matter what is the distance between waypoints - used by 
    	the most scaried bots).<br>
  	pb experience test_a_CT ind1 ind2 byPathType - shows the path the Counter-Terrorist bot would like to choose from WP ind1 to WP ind2 
  	according to explained above byPathType parameter.<br>
  	pb experience test_a_CTH ind1 ind2 byPathType - shows the path the Counter-Terrorist bot (with following him a hostage/hostages) 
  	would like to choose from WP ind1 to WP ind2 according to explained above byPathType parameter.<br>
	+ FIXED some minor bugs with ducking bots.<br>
	+ Changed - if the bot is forced to camping at non-camp Waypoint - it is trying now to use now the danger direction for that Waypoint 
  	instead just pickuping the random visible WP to camp in that direction.<br>
	+ Changed - the bots are sometimes also ducking while shooting from other than awp weapon (similar to YapB).<br>
	+ Optimized again engine messages usage (thanks ghost_of_evilspy and his jk_botti).<br>
	+ Changed the way of checking if custom body parts (arms, legs, feet) are visible for the bot (to stop random part checks - another 
  	cause of shaking bots).<br>
	+ FIXED bug with jumping bots after camping and after reaching the destination waypoint during the normal navigation movement.<br>
	+ Changed the way of calculating the vertical position of landing of the grenade (if the enemy is above or under the bot).<br>
	</span></li>

  <li><a name="XXI"></a>V 3.0 metamod Build 20a
  <span>
	+ Added the invisibility check, so if the player is invisible, the bot cannot see him (at least until invisible player is starting 
		to shoot at him - then - he can see the fire from his gun, so he is trying to answer with fireing at that direction).<br>
	+ Added affecting bots by darkness (thanks to PMB and his RACC code) - same like above - if in the dark room the enemy is starting to fire 
		at the bot, so he can see the fire from the enemy\\\'s gun - then the bot is fireing at that direction, too.<br>
	+ Expressed the meaning of pb_detailnames cvar (0 - no skill and no [POD] prefix, 1 - skill as sufix and [POD], [P*D] and [P0D] prefixes 
		added to the name; 2 - only the prefix is added to the name (no skill as the sufix added); 3 - only the skill sufix is added 
		(no [POD] tags added).<br>
	+ Added pb_maxcamptime cvar (default 30) - the maximum time You allow the bot camping in one place - after that time it has 
		to go to another place.<br>
	+ FIXED problem with reloading the weapon at the round start.<br>
	+ Added - if the bot has less money than 900, sometimes they will try to save the money by not buying any new weapon.<br>
	+ Changed - reverted back - the bot is taking care about the closest sound instead of the most loud one. The sound is also affecting 
		the bot at least 1 second again (to prevent changing aim direction too often when hearing something).<br>
	+ FIXED - if there is no enemy nearby and the bot is going to pass the door, the bot is facing the door to open them 
		in the right direction.<br>
	+ FIXED - when the bot is turned into the chicken (ChickenMod), it is now able to pickup hostages and defuse the bomb.<br>
	+ Added more code for Ts to better choose the bombzone (if too many enemies near the closests bomb-spot, the bot is trying 
		to go to another one).<br>
	+ Changed - if the bot has more money and already has a primary weapon, he is buying now a better primary weapon.
		The bot is not droping the higher price weapon at the new round start to buy the cheaper one - but in his opinion - better one.<br>
	+ Changed - for linux i386.so version - statically linked with libstdcc++6.so - big thanks to THE_STORM for figuring it out.<br>
	+ Changed - if the bot is chickened, it is not buying any primary nor secondary weapon anymore (the new coming ChickenMod is forcing 
		the player to drop the gun, so no reason to lose money by the bot).<br>
	+ Changed the code for CTs to better find the planted bomb.<br>
	+ Added - since the bots are affected by darkness, they have to use flashligths. Thanks THE_STORM and Immortal_BLG for tips.<br>
	+ Added more info for wrong waypoints connection "Waypoint problem. No path found" message should also say between which nodes 
		the path is missing).<br>
	+ FIXED the bug with radio commands the bots were saying to nobody (if none of teamnates was yet alive).<br>
	+ FIXED the bug with pb_mapstartbotdelay (thanks to Orangutanz to point it out) and pb_wptfolder cvars not loaded for the first map.<br>
	+ Added the new cvar pb_latencybot [0|1] which lets You show one the scoreboard the string [BOT] instead nothing.
		Note - it works only when the bot is adding/creating, so changing the cvar later doesn't affect any bot already in-game.<br>
	+ Changed a bit behavior of using flashlights (no longer used while attacking or they can hear the enemy nearby 
		- so they aren't easy target anymore).<br>
	+ Addded - the bots are buying and using nightgoogles on dark maps.<br>
	+ Changed - the bots are no longer trying to use any weapon except knife if they are zombies.<br>
	+ Changed - the bots are trying to hunt/attack the enemies and jump more often if they are chickens/zombies.<br>
	+ FIXED problem with TeamInfo messages, so the bots should know better who is a friend and who is an enemy now.<br>
	+ FIXED problem with bots jumping while shooting from the sniper weapon.<br>
	+ Changed some code with pickup/defuse/attack priorities.<br>
	+ Changed - the bots as chicken and zombies are hunting their enemies yet more aggressive.<br>
	+ FIXED - Bot better uses the zoom (instead zooming in/out all the time) of sniper and assault weapons.<br>
	+ FIXED - When the bomb is planted the bots wanted to go to the target using the shortest path (so all of them could get easy get killed 
		by waiting Ts). Now they are getting the path according to the "danger" data experience.<br>
	+ FIXED - Bots were trying to get the same waypoint to camping while defending some position (for example the planted bomb).<br>
	+ Changed - the bots are trying to hit the enemy behind the obstacle more often now (if he could be seen or heard before).<br>
	+ Changed - the bots are not trying to spray so much the ammo for the enemy behind the wall (just a little bit and with some interval 
		time (15sec) it may happen again).<br>
	+ Changed - Filtering the aiming position to don't switch too often the position the bot should look at.<br>
	+ FIXED - The bot is switching now to the secondary weapon for short distances to the enemy, when is using the sniper weapon.<br>
	+ Changed - The nade throwing - the bot checks where the enemy is looking at (if visible) to prevent to be an easy target (or throws it 
		at near expected enemy's position - if the enemy is behind some obstacle).<br>
	+ Changed - Some functions more frequently called are using static variables now, so it should be better optimized in execution now.<br>
	+ FIXED problem with bots looking very often at the ceilling.<br>
	+ Changed - Forcing CT bots stop camping and trying to defuse the bomb if the defuser got killed.<br>
	+ Changed a bit method of checking if the entity to pickup (i.e. bomb) is visble.<br>
	+ FIXED - bots unable to find the bomb partially visible (by Ts and CTs).<br>
	+ Changed a bit blinded behaviour of the bot.<br>
	+ FIXED bots trying to avoid an approching grenade didn't check if they may fall down while moving back.<br>
	+ FIXED bots reloading the weapon didn't check if they may fall down while moving back.<br>
	+ FIXED - the bot should answer positive for the command "Follow me" only in the case it is really going to follow its "user".<br>
	+ Changed a bit the check for throwing grenade direction - it should prevent to throw the nade in weird directions (at least 50% reduced).<br>
	+ FIXED - CT bots are finding better the bomb to defuse it if they are nearby.<br>
	+ FIXED - bots weren't avoiding the nades throwing in their direction.<br>
	+ FIXED - better affecting bots by smoke grenades and flashbangs.<br>
	+ Changed - the bots should better aim the new WP while walking (so they should faster change the direction to go - better following waypoints).<br>
	+ FIXED - "Taking fire, need assistance" command was issued even if the enemy wasn't fireing at the bot.<br>
	+ FIXED - the bots shaking and circling effect (reduced 99%).<br>
	+ FIXED - the bots strafing while doing attack movement.<br>
	+ FIXED the calculation of the path's length according to the "danger" data experience.<br>
	+ FIXED the problem with spinning bot while throwing nades.<br>
	</span></li>
	
  <li><a name="XXII"></a>V 3.0 metamod Build 21
  <span>
	+ FIXED - problem with CT bots not defusing the bomb sometimes (no anyone nearby and they didn't defuse).<br>
	+ FIXED - problem with usage of buttons triggering double door (consisting left and right part like on cs_chemical).<br>
	+ Changed - aiming for moving targets.<br>
	+ Optimized the code for lookup enemies - it should reduce the CPU usage about 30%.<br>
	+ Changed - optimized the code for unstuck bots (especially when the bot is stuck with other bots/players).<br>
	+ Changed - finding \\\"BestWaypoint\\\" for navigation (if the new WP in path is used by another bot/player, the bot will take 
	another WP connected with the previous and next WP only if the next is visible from the prevoius one 
	- that check was prevoiously missing).<br>
	+ Reverted back - the check if the heard/last enemy is far away behind any obstacle (to prevent look the bots at the wall).<br>
	+ Added - if the bot follows waypoints while walking according to the path and it has to change the direction more than 60 degrees (if it would 
	continue exactly the same direction - the angle would be 0 degrees) and waypoints radius is smaller than 17 then the bot slows down for 0.5 sec 
	and then it continues normal walking. That should prevent the situation when - i.e. - the bot changes the direction 90 degrees and it hits the wall 
	instead the door.<br>
	+ FIXED - problem with bots looking wrong direction at walking (in most cases they should look forward, but it may happen they are also 
	looking at danger position - which isn't forward). That should reduce their looking at the wall.<br>
	+ FIXED - problem with not updating the global experience if the overflow of experience data was about to happen.<br>
	+ Reverted back some function in sound slimulation (the sample of the sound is now also taken in account for 1.2 sec instead of 1 sec; 
	the new sample is taken into account if the new sample's volume is higher than the old one).<br>
	+ Added - "pb help" function (i.e. You can write in the console "pb help add" to see more info about "pb add" command. 
	That function was missing since the time SpLoRyGoN was coding podbot mm; he haven't had time to do it, but he really wanted it.<br>
	+ FIXED - the code for cleaning unnecessary connections - it should take care more about any waypoint with JUMP flag, so You shouldn't need 
	to repeat Your jumps to save them again because the code was cleaning some jumps connections, too.<br>
	+ Changed - the functionality of pb_latencybot cvar. Now when You set it to 2, it starts to show virtual random ping for bots 
	(it gets random from 30-50 range value).<br>
	+ Added new function when the bot is falling down at least half a second, it should press "use" button (to support parachute AMX/AMXX plugins). 
	It works only if sv_parachute cvar exists and it is set to 1.<br>
	+ Added - when the first player joins a Ts or CTs team on the server and there are bots only, the round is restarted in 1 second.<br>
	+ Removed the check for dead players if the user is with NOCLIP movement flag.<br>
	+ FIXED - the problem with radio commands - when the cvar pb_radio is 0, bots should still react on radio messages (they just don't answer 
	by radio).<br>
	+ FIXED - the problem with hostages staying above a bot (i.e. on a box), the hostage wasn't "used" by a bot. That should also help with defusing 
	a bomb on a box.<br>
	+ FIXED - the problem with fast direction change when the bot is moving and no enemy around (they should rotate now more smoothly).<br>
	+ FIXED - the problem with chat messages not filling the string with a name of the player the message is related to.<br>
	+ FIXED - the problem with chat messages parsing players names with a space (i.e. if the player had a name "James Bond" in the message string 
	it was only "James").<br>
	+ Changed the delay time bots would answer to chat messages (that should prevent bots to overflood the chat area).<br>
	+ Changed the chat usage - the bots should chat less often (they shouldn't spam the chat area).<br>
	+ FIXED - "shoot at death time" is working now as it should (when the bot kills an enemy, he is still trying to shoot at the same direction 
	for a random period - 0.3-1.0sec).<br>
	+ FIXED - the problem with bots neverending trying to break some unbreakable obstacle (after short time that unbreakable obstacle gets 
	ignored by a bot now).<br>
	+ FIXED other things concerning to shaking bots.<br>
	+ Changed time of displaying the message about PWF creator (12 seconds after the new round is started after the player joined the server.<br>
	+ Changed time of displaying the welcome message (15 seconds after the new round is started after the player joined the server.<br>
	+ FIXED the problem with bots switching the weapon to the knife in the middle of reloading the weapon.<br>
	+ FIXED the problem with bots sometimes not hearing the enemy even if he was really close to them.<br>
	+ FIXED the problem with bots not trying to seek the cover while reloading the weapon.<br>
	+ Changed the selection of task ENEMYHUNT and SEEKCOVER.<br>
	+ FIXED bug with pushing away bots on the edge of the roof - they shouldn't fall down now.<br>
	+ FIXED bug with pushing away bots in smaller areas.<br>
	+ Cleaned the code (exactly some functions are splitted to let the coder easier find a specific code).<br>
	+ FIXED bug with bots throwing nades in some random places.<br>
	+ FIXED bug with bots looking at the wall for longer time.<br>
	+ FIXED the problem with bots not trying to switch to secondary weapon in short distances (if they are using snipers i.e.).<br>
	+ FIXED the bug with bots not shooting to enemies farer away than 4096 units.<br>
	+ Reduced again bots shaking problem.<br>
	+ FIXED the bug with bots not overjumping obstacles while they are stuck.<br>
	+ FIXED the bug with bots jumping after spawning.<br>
	+ Changed - bots shouldn't camp if they have a shotgun or m241.<br>
	+ Added 1 new command (exactly old command with new argument) for waypointers:<br>
		pb wp teleport goal - teleports the waypointer to the next waypoint with the flag GOAL.<br>
	+ Changed the default value of pb_dangerfactor from 800 to 2000 (it may affect the server performance on an older PC).<br>
	+ Changed - bots are buying weapons on an aim_xxx and awp_xxx maps, too, if info_map_parameters allows that.<br>
	</span></li>

<!-- ###END: MainContent### -->
      </ul>
     </td>
    </tr>
   </table>
  </td>
 </tr>
<!-- ###END: MainContent Table### -->
</table>
<!-- ###END: Body### -->
</body>
</html>